
%% Test of the C++ algorithm for the Joint Space Inertia Matrix (JSIM) generated
%% by RobCoGen, for fixed base robots.
%%
%% Usage: [ME ROY] = testcpp_jsim(ROY_MODEL, EXE)
%%
%% ROY_MODEL is the robot model (a data structure) in Roy's format.
%%
%% EXE is the full path of the program running the C++ code generated by
%% RobCoGen for the computation of the JSIM, for the same robot.
%% The program must take command line arguments for each coordinate of the
%% joint status vector.
%%
%% That is, the program must be executable in this form:
%%    "<exe> q0 q1 .. qn"
%%
%% See readme.md for more information and general documentation on the inputs
%% of this function.
%%
%% Author: Marco Frigerio
%
%%% This file is part of the Octave test functions for RobCoGen.
%%% Copyright © 2016 2017, Marco Frigerio (`marco.frigerio@iit.it`)
%%% See the LICENSE file for more information.

function [me roy] = testcpp_jsim(roy_model, exe)

dof = length(roy_model.jtype);

q   = rand(dof,1) * 2;
qd  = rand(dof,1) * 2;

[foo me] = system( [ exe ' ' num2str([q'])] );
me = str2num(me);

%
% Roy's implementation
%
[H,C] = HandC( roy_model, q, qd );
roy = H;
err = roy - me;
err( abs(err) < 1E-5 ) = 0;

disp(err);

