#ifndef IIT_ROBOT_FANCY_MODEL_CONSTANTS_H_
#define IIT_ROBOT_FANCY_MODEL_CONSTANTS_H_

/**
 * \file
 * This file contains the definitions of all the non-zero numerical
 * constants of the robot model (i.e. the numbers appearing in the
 * .kindsl file).
 *
 * Varying these values (and recompiling) is a quick & dirty
 * way to vary the kinematics/dynamics model. For a much more
 * flexible way of exploring variations of the model, consider
 * using the parametrization feature of RobCoGen (see the wiki).
 *
 * Beware of inconsistencies when changing any of the inertia
 * properties.
 */

namespace iit {
namespace Fancy {

static constexpr double m_base0 = 1.0;

static constexpr double m_link1 = 1.0;
static constexpr double comx_link1 = 0.5;
static constexpr double ix_link1 = 0.0025;
static constexpr double iy_link1 = 0.33458;
static constexpr double iz_link1 = 0.33458;

static constexpr double m_link2 = 1.0;
static constexpr double comz_link2 = 0.5;
static constexpr double ix_link2 = 0.33458;
static constexpr double iy_link2 = 0.33458;
static constexpr double iz_link2 = 0.0025;

static constexpr double m_link3 = 1.0;
static constexpr double comx_link3 = 0.5;
static constexpr double ix_link3 = 0.0025;
static constexpr double iy_link3 = 0.33458;
static constexpr double iz_link3 = 0.33458;

static constexpr double m_link4 = 1.0;
static constexpr double comz_link4 = 0.5;
static constexpr double ix_link4 = 0.33458;
static constexpr double iy_link4 = 0.33458;
static constexpr double iz_link4 = 0.0025;

static constexpr double m_link5 = 1.0;
static constexpr double comx_link5 = 0.5;
static constexpr double ix_link5 = 0.0025;
static constexpr double iy_link5 = 0.33458;
static constexpr double iz_link5 = 0.33458;
static constexpr double tx_ee = 1.0;


static constexpr double tx_jB = 1.0;

static constexpr double tz_jC = 1.0;

static constexpr double tx_jD = 1.0;

static constexpr double tz_jE = 1.0;


}
}
#endif
