#include <iostream>

#include <iit/robcogen/test/dynamics_consistency.h>

#include <iit/robots/fancy/inertia_properties.h>
#include <iit/robots/fancy/transforms.h>
#include <iit/robots/fancy/traits.h>


using namespace std;
using namespace iit;
using namespace iit::Fancy;

/**
 * This program calls the dynamics-consistency-test implemented in
 * iit::robcogen::test.
 *
 * No arguments are required, all the relevant joint-space quantities are
 * randomly generated.
 *
 * The test prints some output on stdout. All the numerical values should be
 * zero; if that is not the case, there is some inconsistency among the generated
 * dynamics algorithms.
 */
int main(int argc, char** argv)
{
    MotionTransforms xm;
    ForceTransforms  xf;
    dyn::InertiaProperties ip;

    robcogen::test::consistencyTests<Traits>(ip, xm, xf);

    return 0;
}

