%% Possibly fix the paths according to your configuration

[rc spv2] = system('locate -b spatial_v2'); % does not work in every OS
if( rc != 0 )
    error('Could not find spatial_v2 on the file system. Aborting');
end
spv2 = spv2(1:end-1); % get rid of garbage

addpath(genpath( spv2 ) );                % The root of spatial_v2
addpath('../gen-code/octave/fancy');      % The robot-specific Octave generated code
addpath('../gen-code/models');            % This is where Roy's model file is
addpath('../../octave-tests/src/');       % The RobCoGen Octave-tests source code
addpath('../../octave-tests/src/cpp/');   %


exe_id = './build/id';
exe_fd = './build/fd';
exe_im = './build/jsim';

me.kk = modelConstants();
me.ip = inertiaProperties(me.kk);
me.xm = initMotionTransforms(me.kk);
me.xf = initForceTransforms(me.kk);

roy.model = Fancy( me.kk );
