#!/usr/bin/octave -qf

## This Octave program demonstrates how to use the octave-tests shipped with
## RobCoGen, to test the generated code (both Octave and C++).

## Please also read the readme.md in the octave-tests root folder.

run octave-startup.m


printf('\nTest of the generated Octave code for the Joint Space Inertia Matrix\n');
[me.res roy.res] = test_jsim(roy.model, me);

printf('\nTest of the generated Octave code for Inverse Dynamics\n');
[me.res roy.res] = test_id(roy.model, me);


printf('\nTest of the generated C++ code for the Joint Space Inertia Matrix\n');
[me.res roy.res] = testcpp_jsim(roy.model, exe_im);

printf('\nTest of the generated C++ code for Inverse Dynamics\n');
[me.res roy.res] = testcpp_id(roy.model, exe_id);

printf('\nTest of the generated C++ code for Forward Dynamics\n');
[me.res roy.res] = testcpp_fd(roy.model, exe_fd);
